var KeyHandler = {
    MainMenuAnchor : null,
    LivePlayerAnchor : null,
    EpgMenuAnchor : null,
	CategoryMenuAnchor : null,
    ArchivePlayerAnchor : null,
    VideothekMenuAnchor : null,
    VideothekPlayerAnchor : null,   
	Selectbox : null,
	VideothekPlayerControllAnchor : null,
	VideothekGenreSelectorAnchor : null,
	NumberEntered : '',
	ChSelectorTimeout : null,
	black_line : false,
}



KeyHandler.create = function() {
    this.MainMenuAnchor  =  document.getElementById("MainMenu_Anchor");
    this.LivePlayerAnchor  =  document.getElementById("LivePlayer_Anchor");
    this.EpgMenuAnchor =  document.getElementById("EpgMenu_Anchor");
    this.ArchivePlayerAnchor  =  document.getElementById("ArchivePlayer_Anchor");
	this.CategoryMenuAnchor  =  document.getElementById("CategoryMenu_Anchor");
	this.VideothekPlayerAnchor = document.getElementById("VideothekPlayer_Anchor");
	this.SelectboxAnchor = document.getElementById("Selectbox_Anchor");
	this.VideothekPlayerControllAnchor = document.getElementById("VideothekPlayerControll_Anchor");
	this.VideothekGenreSelectorAnchor = document.getElementById("VideothekGenreSelectorAnchor");
    	
}

KeyHandler.setFocus = function(menuID) {  
	ConsoleLog('KeyHandler.setFocus ' + menuID);
    switch(menuID)
    {
		case Main.MainMenu_ID:
			this.MainMenuAnchor.focus();
			break;
		case Main.LivePlayer_ID:
			this.LivePlayerAnchor.focus();
			break;
		case Main.EpgMenu_ID:
			this.EpgMenuAnchor.focus();
			break;
		case Main.ArchivePlayer_ID:
			this.ArchivePlayerAnchor.focus();
			break;
		case Main.CategoryMenu_ID:
			this.CategoryMenuAnchor.focus();
			break;
		case Main.VideothekPlayer_ID:
			this.VideothekPlayerAnchor.focus();
			break;			
		case Main.Selectbox_ID:
			this.SelectboxAnchor.focus();
			break;
		case Main.VideothekPlayerControll_ID:
			this.VideothekPlayerControllAnchor.focus();
			break;
		case Main.VideothekPlayerGenres_ID:
			this.VideothekGenreSelectorAnchor.focus();
			break;
    default:
      alert("Unhandled key");
    }    
}

/*
650 TXT MIX
259 PREV CH
Dual: 655
AD: 0
SUB: 652
GUID 651
*/

/* SERIE D
case 1252://KEY_SEARCH
case 1251://KEY_SOCIAL
*/

/*
147://KEY_INFOLINK
*/
	 
		
KeyHandler.KanalSelector = function() 
{

	var channel_nummer = eval(KeyHandler.NumberEntered);

	if(channel_nummer>200)
	{
		if(channel_nummer==999)
		{
			if(KTV_API.webcamstream_url == Player.url)
			{
				KTV_API.getChannel_url(Main.ch_id_selected,0);
				Player.setVideoURL(KTV_API.url);
			}
			else
				Player.setVideoURL(KTV_API.webcamstream_url);
			Player.playVideo();
		}
		else if(channel_nummer==888)
		{
			Display.ShowWebImage();
			setTimeout("Display.HideWebImage()",5000);
		}
		else if(channel_nummer==889)
		{
			if(Display.showimg)
				Display.HideWebImage();
			else
				Display.ShowUpdatableWebImage();
		}
		KeyHandler.NumberEntered = "";
	}
	else if(channel_nummer>KTV_API.chan_counter)
	{
		Display.status('ошибка ввода');
	}
	else if (channel_nummer > 0)
	{
		if(channel_nummer < 11)
			Main.selected_channel = channel_nummer - 1;
		else if((channel_nummer % 10)>0)
			Main.selected_channel = (channel_nummer % 10) - 1;
		else
			Main.selected_channel =  9;
					
		if (Main.selected_channel < 4)
			Main.selected_page = Math.round(channel_nummer / 10);
		else
			Main.selected_page = Math.round(channel_nummer / 10) - 1;
			
		Main.chan_array_index = channel_nummer - 1;
		Main.ch_id_selected = KTV_API.channels[Main.chan_array_index][0];
		
		KeyHandler.PlayChannel();

	}

	KeyHandler.NumberEntered = "";

}

KeyHandler.PlayChannel = function()
{
			if(Main.nguide == 'on')
			{
				Main.nGuideChanSelector();
				Main.nguide = 'off';
			}
			else
			{
				Main.updatePage();
				Main.updateChannel();
				Main.PlayChannel();
			}
}

KeyHandler.Keys10 = function(keyCode)
{
	var number="";
	clearTimeout(Player.kinozal_live_reloader);
	switch(keyCode)
    {    
		case tvKey.KEY_1:
			number="1";
            break;
		case tvKey.KEY_2:
			number="2";
            break;
		case tvKey.KEY_3:
			number="3";
            break;
		case tvKey.KEY_4:
			number="4";
            break;
		case tvKey.KEY_5:
			number="5";
            break;
		case tvKey.KEY_6:
			number="6";
            break;
		case tvKey.KEY_7:
			number="7";
            break;
		case tvKey.KEY_8:
			number="8";
            break;
		case tvKey.KEY_9:
			number="9";
            break;
		case tvKey.KEY_0:
			number="0";
            break;		
		default:
            alert("Unhandled key");
            break;
	}
	
	KeyHandler.NumberEntered = KeyHandler.NumberEntered + number;
	if(number!="" && KeyHandler.NumberEntered != "")
	{
		Display.status(KeyHandler.NumberEntered);
		clearTimeout(this.ChSelectorTimeout);
		this.ChSelectorTimeout = setTimeout("KeyHandler.KanalSelector();", 2000);
	}

}
				
KeyHandler.MainMenuKeyDown = function()
{
    var keyCode0 = event.keyCode;
	ConsoleLog("Key pressed: " + keyCode0);
	KeyHandler.Keys10(keyCode0);
	
	switch(keyCode0)
    {    
		case 652://SUBTITLES TV
		case 1089: //SUBTITLE BD
		case tvKey.KEY_BLUE:
			KTV_API.getSettings();
			break;
			
		case tvKey.KEY_YELLOW:
      pluginAPI.ShowTools(1);
      break;
			
		case tvKey.KEY_GREEN:
			Main.ResetSelectedPosition();
			if(Main.nguide == 'off')
			{
				Main.nguide = 'on';
				KTV_API.getChannel_list();
			}
			else
			{
				Main.nguide = 'off';
				KTV_API.channels = KTV_API.channels_n_temp;
				KTV_API.countPages();
				Display.status('<span id="nguide_color">nGuide</span><br><span style="color:red;">деактивирован</span>');
				Main.Menu();
			}
			break;
			
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			Player.plugin.Stop();
			widgetAPI.sendReturnEvent();
            break;    
            break;

	    case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
            if(Player.state == Player.PLAYING_LIVE)
			{
				if(Main.nguide == 'on')
				{
					Main.nguide = 'off';
					KTV_API.channels = KTV_API.channels_n_temp;
					KTV_API.countPages();
					Display.status('<span id="nguide_color">nGuide</span><br><span style="color:red;">деактивирован</span>');
				}
				Main.selected_channel = Player.selected_channel;
				Main.selected_page = Player.selected_page;
				Main.chan_array_index = Player.chan_array_index;
				Main.updateCurrentChannelEPG();
				Main.UpdatePlayerStatusbar();
				KeyHandler.setFocus(Main.LivePlayer_ID);
				Main.MODE = Main.LivePlayer_ID;
				Display.showplayer();
				Display.hidemenu();
			}
            if(Player.state == Player.PLAYING_ARCHIVE)
			{
				KeyHandler.setFocus(Main.ArchivePlayer_ID);
				ArchivePlayer.UpdatePlayerStatusbar();
				Display.showplayer();
				Display.hidemenu();
			} 			
            break;
			
		 case tvKey.KEY_DOWN:
            Main.selectNextChannel();
            break;
            
        case tvKey.KEY_UP:
            Main.selectPrevChannel();
            break;            
		
        case tvKey.KEY_ENTER:			
			KeyHandler.PlayChannel();
            break;
	
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break; 

		case tvKey.KEY_TOOLS: //Menu
            Setup.setFormular();
            break;

		case tvKey.KEY_INFO:
			Main.updateModeText('true');
			if(KTV_API.channels[Main.chan_array_index][4])
			{				
				EPG.come_from = 0;
				EPG.epg_day = 0;
				EPG.setDate();
			}
            break;	

		case tvKey.KEY_PLAY:
			Main.updateModeText('true')
			VideothekPlayer.Start();
            break;		

		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;
		
		//case 256://KEY_FAVCH EMU
		case 1057: // TITLE MENU
		case tvKey.KEY_CHLIST:
		case tvKey.KEY_STOP:
			widgetAPI.blockNavigation(event);
			if((Main.FAV_MODE == 0) && (KTV_API.favorite_list.length>0))
			{
				KTV_API.channels = KTV_API.favorite_channels;
				Main.FAV_MODE = 1;
				Player.prev_ch_array = new Array();
			}
			else if((Main.FAV_MODE == 0) && (KTV_API.favorite_list.length==0))
			{
				Display.status("список фаворитов пуст");
			}
			else if(Main.FAV_MODE == 1)
			{
				if(Main.cat_id!=999)
					KTV_API.getChannel_list();
				KTV_API.channels = KTV_API.video_Channels;
				Main.FAV_MODE = 0;	
				Player.prev_ch_array = new Array();				
			}
			KTV_API.countPages();
			Main.nguide='off';
			Main.Menu();
            break;	
			
        case tvKey.KEY_FF:
            Main.add_favorite();
			Main.saveFavorites();
            break;
        
        case tvKey.KEY_RW:
            Main.del_favorite();
			Main.saveFavorites();
            break;
			
        case tvKey.KEY_PAUSE:
            Display.status("CH-ID: " + Main.ch_id_selected);
            break;
			
        case tvKey.KEY_RED:
			Main.showCategorySelector();
			break;
		
		case tvKey.KEY_REC:
			//Display.status("LOADING");
			KTV_API.getChannel_list();
			Main.nguide='off';
			setTimeout("Main.Menu();", 7000);
			break;
/*
		case tvKey.KEY_PAUSE:
			KTV_API.getChannel_list();
			if(Main.nguide=='on')
			{
				KTV_API.nGuideChanList();
				Main.Menu();
			}
			else
			{
				Main.nguide='off';
				Main.updatePage();
				Main.updateChannel();
			}
			Display.status("RELOADED");
            break;
*/
		case tvKey.KEY_LEFT:
            Main.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:		
            Main.selectNextPage();
            break;
/*
		case 65://KEY_CH_DOWN     
			Main.ch_update_mode = false;
			Main.selectNextPage();
            break;
            
		case 68://KEY_CH_UP
			Main.ch_update_mode = false;
			Main.selectPrevPage();
            break;  
*/
		case 68://KEY_CH_UP
			if(Display.showimg)
				Display.HideWebImage();
			else
				Display.ShowUpdatableWebImage();
			break;
			 
		case 65://KEY_CH_DOWN
			Display.ShowWebImage();
			setTimeout("Display.HideWebImage()",5000);
			break;			

		default:
            alert("Unhandled key");
            break;
    }
}	

KeyHandler.LivePlayerKeyDown = function()
{
	var keyCode1 = event.keyCode;
	alert("Key pressed: " + keyCode1);
	KeyHandler.Keys10(keyCode1);	
	
	switch(keyCode1)
    {			
		case 259://PRE-CH EMU
			Player.PlayPrevChannel();
			break;
		
		case tvKey.KEY_PAUSE:
		widgetAPI.blockNavigation(event);
            if (Screen.getModeD()>=2)
                Screen.changeModeD(0);
			else
				Screen.changeModeD(Screen.getModeD()+1);
            break;

		case tvKey.KEY_PLAY:
		case 1219://KEY_3D
		widgetAPI.blockNavigation(event);
            if (Screen.getModeD2()>=2)
                Screen.changeModeD2(0);
			else
				Screen.changeModeD2(Screen.getModeD2()+1);
            break;
			
		case 653://KEY_ASPECT
		case 1249:// FULL SCREEN  BD
		case 1086: //BD DISC MENU
		case 256://KEY_FAVCH EMU
		case tvKey.KEY_BLUE:
			widgetAPI.blockNavigation(event);  
            if (Player.getSize()>=3)
                Player.setSize(0, 1);
			else
				Player.setSize(Player.getSize()+1, 1);
            break;

		case tvKey.KEY_RED:
			Player.HideCossEyeHelpBar();    
            break;

		case tvKey.KEY_GREEN:
			Player.HideCossEyeMode();    
            break;
                        
 
		 case tvKey.KEY_LEFT:
		 case 65://KEY_CH_DOWN
            Main.selectPrevChannel();
			Main.PlayChannel();
            break;
            
        case tvKey.KEY_RIGHT:
		case 68://KEY_CH_UP
            Main.selectNextChannel();
			Main.PlayChannel();
            break;            
			
        case tvKey.KEY_ENTER:
			Display.showplayer();
            break;
			
			
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break; 			

		case tvKey.KEY_INFO:
		//case tvKey.KEY_GUIDE:
			if(KTV_API.channels[Main.chan_array_index][4])
			{	
				Display.hideplayer();
				Display.showmenu();
				EPG.come_from = 1;
				EPG.show();
			}
            break;			

		case tvKey.KEY_TOOLS: //LivePlayer
            pluginAPI.ShowTools(1);
            break;
			
		case 1057: //KEY_12 TITLE MENU
		case tvKey.KEY_CHLIST:
		case tvKey.KEY_EXIT:
		case tvKey.KEY_MENU:
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);  
			Display.hideplayer();
            Display.showmenu();
			Main.Menu();
			break;


		/*	
		case tvKey.KEY_BLUE:	
			if(Main.stats!=1)
			{
				Main.showStats();
				Main.stats = 1;
			}
			else
			{
				document.getElementById("selectbox").style.display="none";
				Main.stats = 0;			
			}
			break;  */
			
		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;
			
		case tvKey.KEY_STOP:
			if(this.black_line)
			{
				document.getElementById("black_line_top").style.display="none";	
				this.black_line = false;
			}
			else
			{
				document.getElementById("black_line_top").style.display="block";
				this.black_line = true;
			}
			break;

		case tvKey.KEY_YELLOW:
			pluginAPI.ShowTools(0);
            break;

		case tvKey.KEY_REC:
			Player.matrixReload();
			KTV_API.getChannel_list();
			break;
			
		default:
            alert("Unhandled key");
            break;
	}
}
	
KeyHandler.EpgMenuKeyDown = function()
{
    var keyCode2 = event.keyCode;
    alert("Key pressed: " + keyCode2);

    switch(keyCode2)
    {

		case tvKey.KEY_RETURN:
            widgetAPI.blockNavigation(event); 
			if(EPG.come_from==0)
				Main.Menu();
			if(EPG.come_from==1)
			{
				KeyHandler.setFocus(Main.LivePlayer_ID);
				Display.hidemenu();
				Display.showplayer();
			}
			if(EPG.come_from==2)
			{
				KeyHandler.setFocus(Main.ArchivePlayer_ID);
				ArchivePlayer.mode = 0;
				Display.hidemenu();
				Display.showplayer();
			}
            break; 
			
		case 1057: //KEY_12 TITLE MENU
		case tvKey.KEY_CHLIST:
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			if(Player.state != Player.PLAYING_LIVE)
			{
				Main.PlayChannel();
			}
			EPG.date = null;
			Display.hideplayer();
			Display.showmenu();
			Main.Menu();
			break; 	

		case tvKey.KEY_DOWN:;
            EPG.selectNextProgram();
            break;
            
        case tvKey.KEY_UP:
            EPG.selectPrevProgram();
            break;            

		case tvKey.KEY_LEFT:
            EPG.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:
            EPG.selectNextPage();
            break;
			
        case tvKey.KEY_ENTER:
			EPG.PlayChannel();
            break;
			
        case tvKey.KEY_FF:
            EPG.nextDay();
            break;
        
        case tvKey.KEY_RW:
            EPG.prevDay();
            break;
			
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break; 	
			
		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;

		case 68://KEY_CH_UP
			if(Display.showimg)
				Display.HideWebImage();
			else
				Display.ShowUpdatableWebImage();
			break;
			 
		case 65://KEY_CH_DOWN
			Display.ShowWebImage();
			setTimeout("Display.HideWebImage()",5000);
			break;			
			
        default:
            alert("Unhandled key");
            break;
    }	
}

KeyHandler.ArchivePlayerKeyDown = function()
{
	var keyCode3 = event.keyCode;
	alert("Key pressed: " + keyCode3);
			
	switch(keyCode3)
    {

		case 653:
		case 1086: //BD DISC MENU
		case 1249:// FULL SCREEN  BD
    case tvKey.KEY_BLUE:		
            if (Player.getSize()>=3)
                Player.setSize(0, 1);
			else
				Player.setSize(Player.getSize()+1, 1);
            break;
			
        case tvKey.KEY_ENTER:
			Display.showplayer();
            break;
 
		 case tvKey.KEY_LEFT:
			ArchivePlayer.MinutesJump(-1);
            break;
            
        case tvKey.KEY_RIGHT:
			ArchivePlayer.MinutesJump(1);
            break; 
			
		case tvKey.KEY_DOWN:	
			ArchivePlayer.MinutesJump(-3);
            break;
			
		case tvKey.KEY_UP:
			ArchivePlayer.MinutesJump(3);
            break;

        case tvKey.KEY_FF:
            ArchivePlayer.MinutesJump(10);
            break;
        
        case tvKey.KEY_RW:
            ArchivePlayer.MinutesJump(-10);
            break;
			
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break; 			

		case tvKey.KEY_INFO:
			Display.hideplayer();
			EPG.setProgramList();
			Display.showmenu();
			EPG.come_from = 2;
			ArchivePlayer.mode = 1;
			EPG.show();
            break;	

	    case 1057: //KEY_12 TITLE MENU
		case tvKey.KEY_CHLIST:		
		case tvKey.KEY_EXIT:
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Main.PlayChannel();
			EPG.date = null;
			Display.hideplayer();
            Display.showmenu();
			Main.Menu();			
            break;

	    case tvKey.KEY_0:
			ArchivePlayer.PercentJump(0);
			Display.status("0%");
			break;
			
	    case tvKey.KEY_1:
			ArchivePlayer.PercentJump(1);
			break;
			
	    case tvKey.KEY_2:
			ArchivePlayer.PercentJump(2);
			break;
			
	    case tvKey.KEY_3:
			ArchivePlayer.PercentJump(3);
			break;
			
	    case tvKey.KEY_4:
			ArchivePlayer.PercentJump(4);
			break;
			
	    case tvKey.KEY_5:
			ArchivePlayer.PercentJump(5);
			break;
			
	    case tvKey.KEY_6:
			ArchivePlayer.PercentJump(6);
			break;
			
	    case tvKey.KEY_7:
			ArchivePlayer.PercentJump(7);
			break;
			
	    case tvKey.KEY_8:
			ArchivePlayer.PercentJump(8);
			break;
			
	    case tvKey.KEY_9:
			ArchivePlayer.PercentJump(9);
			break;

		case tvKey.KEY_PLAY:
			if(Player.state == Player.PAUSA_ARCHIVE)
				ArchivePlayer.unpauseVideo();
            break;
            
         case tvKey.KEY_PAUSE:
			if(Player.state == Player.PLAYING_ARCHIVE)
				ArchivePlayer.pauseVideo();
			break;

		case tvKey.KEY_RED:
			Player.HideCossEyeHelpBar();    
            break;

		case tvKey.KEY_GREEN:
			Player.HideCossEyeMode();    
            break;

		case tvKey.KEY_YELLOW:
            pluginAPI.ShowTools(0);
            break;
			
		case tvKey.KEY_TOOLS://Archive Player
            pluginAPI.ShowTools(1);
            break;
			
		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;

		case 68://KEY_CH_UP
			if(Display.showimg)
				Display.HideWebImage();
			else
				Display.ShowUpdatableWebImage();
			break;
			 
		case 65://KEY_CH_DOWN
			Display.ShowWebImage();
			setTimeout("Display.HideWebImage()",5000);
			break;

		
		default:
            alert("Unhandled key");
            break;
	}
}

KeyHandler.SelectboxKeyDown = function()
{
  
	var keyCode5 = event.keyCode;
	alert("Key pressed: " + keyCode5);
	widgetAPI.putInnerHTML(document.getElementById("mode"), "BUTTON-ID: " + keyCode5);
			
	switch(keyCode5)
    {
		case tvKey.KEY_DOWN:;
            Selectbox.selectNextItem();
            break;
            
        case tvKey.KEY_UP:
			Selectbox.selectPrevItem();
            break;            
			
        case tvKey.KEY_ENTER:
			if(Main.cat_selector==1)
				Selectbox.SelectChannelGenre();
			else
				Selectbox.SelectVOD();
            break;

		case tvKey.KEY_LEFT:;
            Selectbox.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:
			Selectbox.selectNextPage();
            break;
			
	    case tvKey.KEY_EXIT:
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Selectbox.selectbox_html.style.display="none";
			
			if(Main.cat_selector==1)
			{
				KeyHandler.setFocus(Main.MainMenu_ID);
				Main.cat_selector=0;
			}
			else
				KeyHandler.setFocus(Main.VideothekPlayer_ID);
            break;
			break;
			
		default:
            alert("Unhandled key");
            break;
	}

}	

KeyHandler.VideothekPlayerKeyDown = function() //MENU
{

	var keyCode4 = event.keyCode;
	alert("Key pressed: " + keyCode4);
			
	switch(keyCode4)
    {
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			if(Player.state == Player.PLAYING_VOD)
			{
				clearTimeout(VideothekPlayer.vod_status_timer);
			}
			Main.PlayChannel();
			document.getElementById("help_navi_vod_player").style.display="none";
			//widgetAPI.putInnerHTML(document.getElementById("version"), "nKTVplayer " + Main.version);
			widgetAPI.putInnerHTML(document.getElementById("version"), "VERSION " + this.version + ' ');
			Display.hideplayer();
            Display.showmenu();
			Main.updateModeText();
			Main.Menu();
			break; 	

		case tvKey.KEY_RED:
			if(VideothekPlayer.vod_selected_mode!="favorites")
			{
				VideothekPlayer.vod_type = 'last';
				VideothekPlayer.vod_selected_page=1;
				VideothekPlayer.vod_selected_item = 0;
				VideothekPlayer.updatePage();
				Display.status("сортировка по дате добавления");
			}
            break;
            
        case tvKey.KEY_GREEN:
			if(VideothekPlayer.vod_selected_mode!="favorites")
			{
				VideothekPlayer.vod_type = 'best';
				VideothekPlayer.vod_selected_page=1;
				VideothekPlayer.vod_selected_item = 0;
				VideothekPlayer.updatePage();
				Display.status("сортировка по количеству просмотров");
			}
            break; 

		case tvKey.KEY_PLAY:
			widgetAPI.blockNavigation(event);
			VideothekPlayer.vod_selected_page = 1;
			VideothekPlayer.vod_selected_item = 0;
			if(VideothekPlayer.vod_selected_mode != 'favorites')
			{
				VideothekPlayer.vod_selected_mode = 'favorites';
				VideothekPlayer.Start();
				Display.status("ИЗБРАННОЕ");
			}
			else
			{
				VideothekPlayer.vod_selected_mode = '';
				VideothekPlayer.Start();
				Display.status("Список всех фильмов");
			}
            break;
			
		case tvKey.KEY_YELLOW:
			if(VideothekPlayer.vod_selected_mode!="favorites")
			{
				Selectbox.setBox("выбор жанра",KTV_API.getGenres());
				KeyHandler.setFocus(Main.VideothekPlayerGenres_ID);
			}
			break;

		case tvKey.KEY_BLUE:
			if(VideothekPlayer.vod_selected_mode!="favorites")
			Search.setFormular();
			break;
			
		case tvKey.KEY_DOWN:;
            VideothekPlayer.selectNextItem();
            break;
            
        case tvKey.KEY_UP:
			VideothekPlayer.selectPrevItem();
            break;            

		case tvKey.KEY_LEFT:
            VideothekPlayer.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:
            VideothekPlayer.selectNextPage();
            break;
			
        case tvKey.KEY_ENTER:
			VideothekPlayer.SelectVOD();
            break;
			
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break; 	

		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			if (Player.state != Player.STOPPED)
			{
				KeyHandler.setFocus(Main.VideothekPlayerControll_ID);
				Display.hidemenu();
				Display.showplayer();
			}			
            break;
			
		case tvKey.KEY_INFO:
            VideothekPlayer.showInfo();
            break;
			
		case 653:	
		case 1086: //BD DISC MENU
		case 1249:// FULL SCREEN  BD
            if (Player.getSize()>=3)
                Player.setSize(0, 1);
			else
				Player.setSize(Player.getSize()+1, 1);
            break;
			
		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;
        
		case tvKey.KEY_STOP:
			if (VideothekPlayer.vod_genre!="")
			{
				VideothekPlayer.vod_genre = "";
				VideothekPlayer.updatePage();
			}
            break;
			
		case tvKey.KEY_PAUSE:
			if (VideothekPlayer.vod_query!="")
			{
				VideothekPlayer.vod_query = "";
				VideothekPlayer.vod_type = "last";
				VideothekPlayer.vod_selected_page=1;
				VideothekPlayer.updatePage();
			}
            break;

		case tvKey.KEY_TOOLS://VideothekMenu
            pluginAPI.ShowTools(1);
            break;

		case tvKey.KEY_FF:
			if(VideothekPlayer.vod_selected_mode!="favorites")
            VideothekPlayer.add_favorite();
            break;
        
        case tvKey.KEY_RW:
			if(VideothekPlayer.vod_selected_mode=="favorites")
            VideothekPlayer.del_favorite();
            break;
			
		case 68://KEY_CH_UP
			if(Display.showimg)
				Display.HideWebImage();
			else
				Display.ShowUpdatableWebImage();
			break;
			 
		case 65://KEY_CH_DOWN
			Display.ShowWebImage();
			setTimeout("Display.HideWebImage()",5000);
			break;
			
		default:
            alert("Unhandled key");
            break;
	}
}

KeyHandler.VideothekPlayerControllKeyDown = function() //PLAYER
{

	var keyCode5 = event.keyCode;
	alert("Key pressed: " + keyCode5);
			
	switch(keyCode5)
    {
		case 1057: //KEY_12 TITLE MENU
		case tvKey.KEY_RETURN:
		case tvKey.KEY_CHLIST:
			widgetAPI.blockNavigation(event);
			if(Player.state == Player.PLAYING_VOD)
			{
				clearTimeout(VideothekPlayer.vod_status_timer);
			}
			KeyHandler.setFocus(Main.VideothekPlayer_ID);
			Display.hideplayer();
            Display.showmenu();
			break;

		 case tvKey.KEY_LEFT:
			Player.MinutesJump(-1);
            break;
            
        case tvKey.KEY_RIGHT:
			Player.MinutesJump(1);
            break; 
			
		case tvKey.KEY_DOWN:	
			Player.MinutesJump(-5);
            break;
			
		case tvKey.KEY_UP:
			Player.MinutesJump(5);
            break;

        case tvKey.KEY_FF:
            Player.MinutesJump(10);
            break;
        
        case tvKey.KEY_RW:
            Player.MinutesJump(-10);
            break;
			
        case tvKey.KEY_ENTER:
			Display.showplayer();
            break;

		case tvKey.KEY_PLAY:
			Player.resumeVideo();
            break;
            
         case tvKey.KEY_PAUSE:
			Player.pauseVideo();
			break;

        case tvKey.KEY_STOP:
			//
			break;
			
	    case tvKey.KEY_0:
			Player.PercentJump(0);
			Display.status("0%");
			break;
			
	    case tvKey.KEY_1:
			Player.PercentJump(1);
			break;
			
	    case tvKey.KEY_2:
			Player.PercentJump(2);
			break;
			
	    case tvKey.KEY_3:
			Player.PercentJump(3);
			break;
			
	    case tvKey.KEY_4:
			Player.PercentJump(4);
			break;
			
	    case tvKey.KEY_5:
			Player.PercentJump(5);
			break;
			
	    case tvKey.KEY_6:
			Player.PercentJump(6);
			break;
			
	    case tvKey.KEY_7:
			Player.PercentJump(7);
			break;
			
	    case tvKey.KEY_8:
			Player.PercentJump(8);
			break;
			
	    case tvKey.KEY_9:
			Player.PercentJump(9);
			break;

		case tvKey.KEY_TOOLS://VideothekPlayer
            pluginAPI.ShowTools(1);
            break;
			
		case tvKey.KEY_YELLOW:
            pluginAPI.ShowTools(0);
            break;
			
		case 653://KEY_ASPECT
		case 1086: //BD DISC MENU
		case 1249:// FULL SCREEN  BD
		case tvKey.KEY_BLUE:
            if (Player.getSize()>=3)
                Player.setSize(0, 1);
			else
				Player.setSize(Player.getSize()+1, 1);
            break;
			
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break;
			
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);    
            break;
			
		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;
			
		case 68://KEY_CH_UP
			if(Display.showimg)
				Display.HideWebImage();
			else
				Display.ShowUpdatableWebImage();
			break;
			 
		case 65://KEY_CH_DOWN
			Display.ShowWebImage();
			setTimeout("Display.HideWebImage()",5000);
			break;			
			
		default:
            alert("Unhandled key");
            break;
	}
}

KeyHandler.VideothekGenreSelectorKeyDown = function()
{

	var keyCode6 = event.keyCode;
	alert("Key pressed: " + keyCode6);
			
	switch(keyCode6)
    {
		case tvKey.KEY_DOWN:;
            Selectbox.selectNextItem();
            break;
            
        case tvKey.KEY_UP:
			Selectbox.selectPrevItem();
            break;            

		case tvKey.KEY_LEFT:;
            Selectbox.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:
			Selectbox.selectNextPage();
            break; 
			
        case tvKey.KEY_ENTER:
			Selectbox.SelectGenre();
            break;
			
	    case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Selectbox.selectbox_html.style.display="none";
			KeyHandler.setFocus(Main.VideothekPlayer_ID);
			break;

		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
            break;    
            break;
			
		default:
            alert("Unhandled key");
            break;
	}

}